;---------------------------------
;FILE:		Sysini.asm
;AUTHOR:		lhmhome.lin and mark by Water.Lee
;COMPANY:		HyCon Tek
;DEVICE:		HY11P13_Z0813AB
;INPUT:		
;OUTPUT:		
;CREATED:		
;UPDATED:		2008/5/21 U 01:52:06
;DESCRIP:		Address initialed.
;TPYE:		Confidential
;---------------------------------                     
SysInit:
	LBSR		00H
      clrf      INTF2,ACCE
      clrf      INTF1,ACCE   

       mvl     00000001b
       mvf     MCKCN1,F,ACCE		; Internal 2Mhz, ADCCLK=500Khz
       						; ADCS[7:5]=000, ADCCLK=HS_ACK/1
       						; 		  001, ADCCLK=HS_ACK/2
       						; 		  010, ADCCLK=HS_ACK/4
       						;		  011, ADCCLK=HS_ACK/8
       						;		  100, ADCCLK=HS_ACK/16
       						;		  101, ADCCLK=HS_ACK/32
       						;		  110, ADCCLK=HS_ACK/64
       						;		  111, ADCCLK=HS_ACK/128
       mvl     00000011b
       mvf     SSPCON1,F,ACCE		; Slave, SCE enable
       						; SSPM[1:0]=00, SPI DʼҦ, ɯ߷ = CPU_CK
       						; 		  01, SPI DʼҦ, ɯ߷ = LS_CK
       						;		  10, SPI QʼҦ, ɯ߷ = SCK޸}, SCE޸}ASCE޸}պAI/Oϥ
       						;		  11, SPI QʼҦ, ɯ߷ = SCK޸}, SCE޸}\Ұ                   
 ;==========Setup VDDA======================================
       mvl     11110000b			; VDDA=2.93V, REFO=1.2V
       						; VDDAX[6:5]=00, VDDA=3.3V
       						;		   01, VDDA=2.93V
       						;		   10, VDDA=2.65V
       						;		   11, VDDA=2.4V
       mvf     PWRCN,F,ACCE        
 ;==============Clear Memory=======================      
       ldpr    080h,FSR0
       mvl     080h
    ClriniMen0:   
       clrf    POINC0,ACCE		; MRAM=080H~0FFH
       dcsz    WREG,F,ACCE
       jmp     ClriniMen0
       ldpr    100h,FSR0
       mvl     80h
    ClriniMen1:   
       clrf    POINC0,ACCE		; MRAM=080H~0FFH
       dcsz    WREG,F,ACCE
       jmp     ClriniMen1
       mvl     00000001b
       mvf     MCKCN2,F,ACCE   	; CPUCK=HS_DCK=1Mhz
       						; HSS[3:2]=00, HS_/1
       						;		 01, HS_/2
       						;		 10, HS_/4
       						;		 11, HS_/8
;==========Setup PT1 Interrupt=======================================
       mvl     00000000b     		; Set  Digital Channel
       mvf     PT1DA,F,ACCE		
       						; 0:DIGITAL, 1:ANALOG
       mvl     10100000b     		; PT1.5 = SDO , PT1.6 = SCK , PT1.2 = SDI;
       mvf     TRISC1,F,ACCE		
       						; 0:INPUT, 1:OUTPUT
       mvl     10100000b
       mvf     PT1,F,ACCE      
       mvl     01011111b
       mvf     PT1PU,F,ACCE  		; Set Pull up Resistor
       						; 1: PULL HIGH
       mvl     00000000b		
       mvf     PT1M1,F,ACCE   	; Set PT1.1/PT1.0 _覡
       						; PT1.1_覡, PT1M1[3:2]=00, CqP
       						;						  01, qP
       						;						  10, qܤƭP
       						;						  11, X
       						; PT1.0_覡, PT1M1[1:0]=00, CqP
       						;						  01, qP
       						;						  10, qܤƭP
       						;						  11, X
       mvl     00000100b		
       mvf     PT1M2,F,ACCE   	; Set SDO output function
       						; PM17[6]=1, BZ OUTPUT
       						; PM16[4]=1, SCK OUTPUT
       						; PM15[2]=1, SDO OUTPUT
       						; PM14[0]=1, TX OUTPUT
 ;==========Setup PT2 =======================================
       mvl     00000000b			; PT2 initialed
       mvf     PT2PU,F,ACCE       
       mvl     00000000b
       mvf     PT2,F,ACCE
       mvl     11110011b
       mvf     TRISC2,F,ACCE		
       MVL	00000000B
       MVF	PT2M1,F,A			; OUTPUT FUNCITON ENABLE
       						; PM22[5:4]=01, PWM0 OUTPUT
       						;		  10, PFD OUTPUT
       						;		  11, X
       						; PM23[6]=1, 	 PWM1 OUTPUT
       MVL	00000000B			
       MVF	PT2M2,F,A			; OUTPUT FUNCITON ENABLE
       						; PM24[1:0]=01, PWM2 OUTPUT
       						;		  10, CCP0 OUTPUT
       						;		  11, X
       						; PM25[3:2]=01, PWM3 OUTPUT
       						; PM27[7:6]=1X, PWM TRI-STATE SETTING
 ;==========Setup ADC0=======================================
       mvl     00000010b			; Chopper OFF, PGA*G=1*1
       mvf     ADC0CN1,F,ACCE
       						; ENCHP[5]=0, CHOPPER ON
       						; PGA[4:3]=00, PGA=1
       						;		 01, PGA=2
       						;		 10, PGA=4
       						;		 11, PGA=8
       						; ADGN[2:0]=000, GAIN=1/4
       						;		  001, GAIN=1/2	
       						;		  010, GAIN=1	
       						;		  011, GAIN=2	
       						;		  100, GAIN=4	
       						;		  101, GAIN=8	
       						;		  110, GAIN=16	
       						;		  111, GAIN=X	
       mvl     00001000b	       	
       mvf     ADC0CN2,F,ACCE		; VREGN=x1/2, DCSET=0
       						; INBUF[5]=VRBUF[4]=1, BUFFER ON
       						; VREGN[3]=1, x1/2
       						;		 0, x1
       						;  INPUT SIGNAL Offset, DCSET[2:0]=000, + 0*VR
       						;						     001, + 1/4*VR
       						;						     010, + 1/2*VR
       						;						     011, + 3/4*VR
       						;						     100, + 0*VR
       						;						     101, - 1/4*VR
       						;						     110, - 1/2*VR
       						;						     111, - 3/4*VR       						
       mvl     11000000b
       mvf     ADC0CN3,F,ACCE		; OSR=32768
       						; OSR[7:5]=000, 256
       						;		 001, 512
       						;		 010, 1024
       						;		 011, 2048
       						;		 100, 4096
       						;		 101, 8192
       						;		 110, 16384
       						;		 111, 32768
       mvl     01101100b			; INH=AI0, INL=AI1, AD INPUT AND OP INPUTu
       mvf     AINET1,F,ACCE
       						; INH[7:5]=000, AI2
       						;		 001, AI6
       						;		 010, AI4
       						;		 011, AI0
       						;		 100, VDD
       						;		 101, REFO
       						;		 110, -TPSH
       						;		 111, +TPSH       						
       						; INL[4:2]=000, AI3
       						;		 001, AI7
       						;		 010, AI5
       						;		 011, AI1
       						;		 100, OP0O
       						;		 101, VSS
       						;		 110, +TPSL
       						;		 111, -TPSL
							; INIS[1]=1, ADCBtݿJHu
							; OPIS[1]=1, LNOPBtݿJHu
	  mvl     01000100b
       mvf     AINET2,F,ACCE		; VRH=AI2, VRL=AI3
       						; VRH[6:5]=00, AI10
       						; 		 01, AI8
       						; 		 10, AI2
       						;		 11, REFO
       						; VRL[2:1]=00, AI11
       						;		 01, AI9
       						;		 10, AI3
       						;		 11, VSS
       						; INX[4:3]=00, INH=SI+, INL=SI-
       						;		 01, INL=SI+, INL=SI-
       						;		 10, INH=SI+, INH=SI-
       						;		 11, INH=SI-, INL=SI+
       mvl     01h				;???????????
       mvf     RAMBKH,F,ACCE
       mvl     00h
       mvf     RAMBKL,F,ACCE
 ;==========Set Timmer=======================================
       bsf     MCKCN3,PERCK,ACCE   ; Select clock source = HS_DCK/32/32
       						; LCDS[7:5]=000, CLOCK=PERA_CK/1
       						;		  001, CLOCK=PERA_CK/2
       						;		  010, CLOCK=PERA_CK/4
       						;		  011, CLOCK=PERA_CK/8
       						;		  100, CLOCK=PERA_CK/16
       						;		  101, CLOCK=PERA_CK/32
       						;		  110, CLOCK=PERA_CK/64
       						;		  111, CLOCK=PERA_CK/128
       						; PERCK[3]= 0, CLOCK=LS_CK/32=PERA_CK		;CLOCK PERA=LS_CK
       						; 		  1, CLOCK=HS_DCK/32/32=PERA_CK	;CLOCK PERA=HS_DCK/32
       						; BZS[2:0]=000,  CLOCK=PERA/1
       						; 		 001,  CLOCK=PERA/2
       						; 		 010,  CLOCK=PERA/4
       						; 		 011,  CLOCK=PERA/8
       						; 		 100,  CLOCK=PERA/16
       						; 		 101,  CLOCK=PERA/32
       						; 		 110,  CLOCK=PERA/64
       						; 		 111,  CLOCK=PERA/128       							
       mvl     00110000b
       mvf     TMACN,F,ACCE     	; 
       						; ENTMA[7]=1, ENABLE TIMER A
       						; TMACK[6]=1, CLOCK=PERA_CK/256
       						;		 0, CLOCK=PERA_CK
       						; TMAS[5:4]=00, pre-scaler: /4
       						; 		  01, pre-scaler: /16
       						; 		  10, pre-scaler: /64
       						; 		  11, pre-scaler: /256       						
 ;==========Set LCD=======================================
       call    ClearLCD			; CLR LCD0~LCD7, ENABLE LCD, PUMP, VLCD=3.05V, BF ON, 1/3BIAS
 ;==========Set Timmer=======================================
       clrf    status,ACCE		
       clrf    SSPSTA,ACCE
       						; SSPBUY[7]=1, ƤMbǰeAF SPIgJĬ줸˴(ȨѶǰeƨϥ)
							; SSPOV[6]=1, : SSPBUFwgOۤW@ơF SPIXXЦ줸
							; 		 SPI QʼҦ:
							; 		 1: SSPBUFwgOۤW@ơA~򱵦@sơA@SSPSRXASSPSRȦsƱN|򥢡CSSPOVuoͦbQʼҦUAYϥuOoeơAϥΪ̤]ŪSSPBUFȦsAHקKSSPOVQ]m1.(ΫOM) 
							; 		 0: oͷ쪬A
							; 		 : bDʼҦUASSPOV줸N|Q]m1, ]Cǰe()ƳݭngJSSPBUFȦsC 
							; BF[0]=1, ASSPBUFwFwľA줸 (Ȩѱƨϥ)
							;	   0, ASSPBUF
       clrf    SPICNT,ACCE
       mvl     0FFh
       mvf     SSPBUF,F,ACCE
       clrf    SPICNT,ACCE
       BCF     SSPCON1,SSPEN,ACCE	;
        						; SSPEN[7]=1, ҰSPIݤf
       						;   		 0, SPIݤf
							; CKP[6]=1, ɯ߷qŶAF   SPI ɯ߷ʿܦ줸
							;	    0, ɯ߷CqŶA
							; CKE[5]=1, ɯ߱qĪAܦŶAɵoeF SPIɯ߷ܦ줸
							;	    0, ɯ߱qŶAܦĪAɵoe 
							;		  : ɯ߷ʥCKP bit (SSPCON1<6>)Mw
							; SMP[4]=1, bƿXɶݱļ˿JơF SPIļ˦줸
							;	SPI DʼҦ:
							;	    1: bƿXɶݱļ˿J
							;	    0: bƿXɶļ˿J
							;	SPI QʼҦ:
							;	    QʼҦUAϥΪ̶NSMP BITM0
							; SSPM[1:0]: SPIҦܦ줸
							; 	    00: SPI DʼҦ, ɯ߷ = CPU_CK
							; 	    01: SPI DʼҦ, ɯ߷ = LS_CK
							; 	    10: SPI QʼҦ, ɯ߷ = SCK޸}, SCE޸}ASCE޸}պAI/Oϥ
							; 	    11: SPI QʼҦ, ɯ߷ = SCK޸}, SCE޸}\Ұ
;==========INTE Set============================
       mvl       01001000b		
       mvf       INTE1,F,ACCE		;ENABLE ADCIE, TMAIE, E1IE
       						; GIE[7]=1, ҥΤ_
							; ADCIE[6]=1, ҥΤ_
							; TMCIE[5]=1, ҥΤ_
							; TMBIE[4]=1, ҥΤ_
							; TMAIE[3]=1, ҥΤ_
							; WDTIE[2]=1, ҥΤ_
							; E1IE[1]=1, ҥPT1.1_
							; E0IE[0]=1, ҥPT1.0_
       mvl       00000000b
       mvf       INTE2,F,ACCE		;ENABLE SPIIE       
							; TXIE[7]=1, TX_ƥҥ
							; RXIE[6]=1, RX_ƥҥ
							; CPOIE[3]=1,CPO_ƥҥ
							; SSPIE[2]=1,SPI_ƥҥ
							; CCP1IE[1]=1,Capture/Compare 1_ƥҥ
							; CCP0IE[0]=1,Capture/Compare 0_ƥҥ
;======================================

	 call     delay10ms
      bsf      ADC0CN1,ENADC,ACCE	;ENABLE ADC
       						; ENADC[7]=1, SD16ҥ
							; ENHIGN[6]=0, ĳ]mC
							; ENCHP[5]=0, SD16chopper ON
							; PGAGN[4:3], PGAvվ㾹
							; 		  11Gx8FLeݿJwľ]by pass input buffer^
							; 		  10Gx4FLeݿJwľ]by pass input buffer^
							; 		  01Gx2FLeݿJwľ]by pass input buffer^
							; 		  00GoffFLPGAj(by pass PGA)AϥΫeݿJwľɥܦC
							; ADGN[2:0], ADvվ㾹
							; 		  111Gϥ
							; 		  110Gx16
							; 		  101Gx8
							; 		  100Gx4
							; 		  011Gx2
							; 		  010Gx1
							; 		  001Gx1/2
							; 		  000Gx1/4

;======================================
	MVL		00001000B
	MVF		OP0CN1,F,A		;CHOPPER HS_DCK/128, OPP=AI7, OPN=AI6
							; ENOP[7]=1, OP ENABLE
							; OPM[6:5]=00,	CHOPPER HS_DCK/64
							;		 01, CHOPPER HS_DCK/128
							;		 10, Positive
							;		 11, Negative
							; OPP[4:3]=00, AI3
							;		 01, AI7
							;		 10, AI10
							;		 11, AI11
							; OPN[2:0]=000, OPXO
							;		 001, AI4
							;		 010, AI5
							;		 011, AI6
							;		 100, AI0 SHORT TO AI5
							;		 101, AI1 SHORT TO AI5
							;		 111, X
							
	CLRF		ADBG+0,A			;AD BUFFER TEMP REGISTER
	CLRF		ADBG+1,A
	CLRF		ADBG+2,A
	CLRF		ADBG+3,A
	CLRF		ADBG+4,A
	CLRF		ADBG+5,A
	CLRF		ADBG+6,A
	CLRF		ADBG+7,A
	CLRF		ADBG+8,A	
	LBSR		001H
	CLRF		ADOFFSETH,B		;AD OFFSET BUFFER
	CLRF		ADOFFSETM,B
	CLRF		ADOFFSETL,B
	CLRF		ADFLAG,A			;AD STATUS
	CLRF		ADGIVECN,B		;AD GIVEUP COUNTER
	CLRF		ADBF,B
	CALL		CLRADBF			;MAD BF      
	;SETF		LCD9,A

RET	
	